clear all;

% Add caffe/matlab to you Matlab search PATH to use matcaffe
addpath('/home/vtu/caffem/matlab/caffe');

% Add tsne/bhtsne to your Matlab search PATH to use bhtsne
addpath('/home/vtu/tsne/bhtsne');

% Change here parameters for visualization - it is for caffe
use_gpu = 0; %-- we will be using CPU mode, change to 1 - for GPU mode

expath = '/home/vtu/caffem/VTU/02cae/mnist10sym02/';
model_def_file = 'mnistCAE10sym0210.prototxt';
model_file = 'mnistCAE10sym0210-02_iter_20000.caffemodel';
TestFileMAT = '/home/vtu/caffe/data/mnistmat/mnist_test.mat';

% Prepare input data
heightW = 28;
widthW = 28;
TE = 10000;

caffein = zeros(heightW, widthW, 1, TE, 'single');
load(TestFileMAT);

for j=1:TE
    for i=1:heightW for k=1:widthW caffein(i, k, 1, j) = test_X(j, k+(i-1)*widthW); end; end
end

% Work with caffe 
matcaffe_init(use_gpu, strcat(expath, model_def_file), strcat(expath, model_file));
pc10 = caffe('forward', {caffein});
pc10 = pc10{1};
caffe('reset');
pc10 = (squeeze(pc10)');

% Work with t-SNE
% We will be using 10 initial dimensions because we have 10 AE outputs
% and we eliminate PCA - the first stage of the t-SNE algorithm

diary(strcat(model_file, '.tsne', '.log'));
no_dims = 2;
initial_dims = 10;
pc2 = fast_tsne(pc10, no_dims, initial_dims);

figure;
gscatter(pc2(:,1), pc2(:,2), test_labels), grid on;
title('Model 2, 10 hidden output neurons + t-SNE');
xlabel('1st dimension');
ylabel('2nd dimension');
saveas(gcf, strcat(model_file, '.Fig2', '.png'));
diary('off');